/* CD2MP3 0.90 (C) 1998 Samuel Audet <guardia@cam.org> */

#define INIFILE "cd2mp3pm.ini"
#define CFGFILE "cd2mp3pm.cfg"

#define INCL_PM
#define INCL_DOS
#include <os2.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include "prfsam.h"
#include "pmsam.h"
#include "cd2mp3pm.h"
#include "cd2mp3.h"
#include "wav2mp3.h"
#include "cd2wav.h"

/* intra process queue */
HQUEUE que;
HEV quesem;
char quename[128];

HWND mainHwnd;
FNWP *wpEF, *wpLB;

/* keeps a list of loaded encoders and grabbers, and their settings */
ENCODER *encoders;
int countEncoders;
GRABBER *grabbers;
int countGrabbers;

/* stuff used during convertion */
ENCODER useEncoder;
GRABBER useGrabber;
int bitrate;
char *wavfilelist;
int wavcount;
int tracklist[256];
int trackcount;
char tempdir[256];
char mp3dir[256];
char basename[256];
char customcd[256];
char custommp3[256];
BOOL hq;
BOOL lowprio;
int thread;
char cddrive;

void ConverterThread(void *arg)
{
	char *listpos;
	int i;

	listpos = wavfilelist;
	while(listpos && *listpos)
	{
      if(!wav2mp3(listpos, mp3dir, bitrate, hq, lowprio, &useEncoder, custommp3, que, quesem, quename))
			break;
		listpos = strchr(listpos,0)+1;
	}

   free(wavfilelist);

	for(i = 0; i < trackcount; i++)
	{
		char tempfile[512];

      sprintf(tempfile, "%s%s_%.2d.wav", tempdir, basename, tracklist[i]);

      if(!cd2wav(cddrive, tracklist[i], tempfile, &useGrabber, customcd, que, quesem, quename))
			break;
      if(!wav2mp3(tempfile, mp3dir, bitrate, hq, lowprio, &useEncoder, custommp3, que, quesem, quename))
			break;
		remove(tempfile);
	}

   WinPostMsg(mainHwnd,WM_COMMAND, MPFROMSHORT(CD2MP3_STOPPED),0);

}

void beginConverter(HWND hwnd)
{
	int i;
	char buffer[512];

	hq = getCheck(hwnd, CB_HQ);
   lowprio = getCheck(hwnd, CB_LOWPRIO);
	getText(hwnd, EF_BASENAME, basename, sizeof(basename));
	getText(hwnd, EF_TEMPDIR, tempdir, sizeof(tempdir));
   if(*tempdir && *(strchr(tempdir,0)-1) != '\\') strcat(tempdir,"\\");
	getText(hwnd, EF_MP3DIR, mp3dir, sizeof(mp3dir));
   if(*mp3dir && *(strchr(mp3dir,0)-1) != '\\') strcat(mp3dir,"\\");
   getText(hwnd, EF_CUSTOMCD, customcd, sizeof(customcd));
   getText(hwnd, EF_CUSTOMMP3, custommp3, sizeof(custommp3));
   getText(WinWindowFromID(hwnd, CB_DRIVE), CBID_EDIT, buffer, sizeof(buffer));
	cddrive = buffer[0];

   *useGrabber.id = 0;
   getText(WinWindowFromID(hwnd, CB_GRABBER), CBID_EDIT, buffer, sizeof(buffer));
   for(i = 0; i < countGrabbers; i++)
	{
      if(!strcmp(grabbers[i].id,buffer))
		{
         useGrabber = grabbers[i];
			break;
		}
	}
   if(!*useGrabber.id)
      updateError("No valid Grabber chosen.");

   *useEncoder.id = 0;
	getText(WinWindowFromID(hwnd, CB_ENCODER), CBID_EDIT, buffer, sizeof(buffer));
	for(i = 0; i < countEncoders; i++)
	{
		if(!strcmp(encoders[i].id,buffer))
		{
			useEncoder = encoders[i];
			break;
		}
	}
   if(!*useEncoder.id)
      updateError("No valid Encoder chosen.");

	getText(WinWindowFromID(hwnd, CB_BITRATE), CBID_EDIT, buffer, sizeof(buffer));
	bitrate = atoi(buffer);

	wavcount = getItemCount(hwnd, LB_WAV);
	if(wavcount)
	{
		char *listpos;
		SHORT arraysize;

		arraysize = 0;
		for(i = 0; i < wavcount; i++)
			arraysize += getItemTextSize(hwnd, LB_WAV, i) + 1;

		arraysize++;
		wavfilelist = listpos = (char *) calloc(arraysize, 1);

		for(i = 0; i < wavcount; i++)
			listpos += getItemText(hwnd, LB_WAV, i, listpos, getItemTextSize(hwnd, LB_WAV, i) + 1) + 1;
	}
	else
		wavfilelist = NULL;

	trackcount = getItemCount(hwnd, LB_TRACK);
	for(i = 0; i < trackcount; i++)
	{
		getItemText(hwnd, LB_TRACK, i, buffer, sizeof(buffer));
		tracklist[i] = atoi(buffer);
	}

	thread = _beginthread(ConverterThread,0,16384,(void *) NULL );
}


MRESULT EXPENTRY wpEFTrack(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
	switch(msg)
	{
		case WM_CHAR:

			if(!(SHORT1FROMMP(mp1) & KC_KEYUP) &&
				  ((SHORT2FROMMP(mp2) == VK_NEWLINE) ||
					(SHORT2FROMMP(mp2) == VK_ENTER)))
			{
				WinSendMsg(WinQueryWindow(hwnd, QW_PARENT),WM_COMMAND,MPFROMSHORT(PB_ADDCD),0);
				return 0;
			}

			break;
	}

	return wpEF( hwnd, msg, mp1, mp2 );
}

MRESULT EXPENTRY wpLBTrack(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
	switch(msg)
	{
		case WM_CHAR:

			if( !(SHORT1FROMMP(mp1) & KC_KEYUP) &&
				  (SHORT2FROMMP(mp2) == VK_DELETE)	)
			{
				WinSendMsg(WinQueryWindow(hwnd, QW_PARENT),WM_COMMAND,MPFROMSHORT(PB_DELETECD),0);
				return 0;
			}

			break;
	}

	return wpLB( hwnd, msg, mp1, mp2 );
}

MRESULT EXPENTRY wpEFWav(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
	switch(msg)
	{
		case WM_CHAR:

			if(!(SHORT1FROMMP(mp1) & KC_KEYUP) &&
				  ((SHORT2FROMMP(mp2) == VK_NEWLINE) ||
					(SHORT2FROMMP(mp2) == VK_ENTER)))
			{
				char buffer[512];

				getText(hwnd,0,buffer,sizeof(buffer));
				if(buffer[0])
				{
					USHORT item = insertItemText(WinQueryWindow(hwnd, QW_PARENT), LB_WAV, 0, buffer);
					selectItem(WinQueryWindow(hwnd, QW_PARENT), LB_WAV, item);
					setText(hwnd, 0, "");
				}

				return 0;
			}

			break;
	}

	return wpEF( hwnd, msg, mp1, mp2 );
}

MRESULT EXPENTRY wpLBWav(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
	switch(msg)
	{
		case WM_CHAR:

			if( !(SHORT1FROMMP(mp1) & KC_KEYUP) &&
				  (SHORT2FROMMP(mp2) == VK_DELETE)	)
			{
				WinSendMsg(WinQueryWindow(hwnd,QW_PARENT),WM_COMMAND,MPFROMSHORT(PB_DELETEWAV),0);
				return 0;
			}

			break;

      case DM_DRAGOVER:
      {
         DRAGINFO *draginfo = (DRAGINFO *)mp1;
         USHORT cItems,i,accept;
         DRAGITEM *dragitem;

         DrgAccessDraginfo(draginfo);
         cItems = DrgQueryDragitemCount(draginfo);
         accept = DOR_DROP;

         for (i = 0; i < cItems; i++)
         {
            dragitem = DrgQueryDragitemPtr(draginfo, i);

            /* Check the rendering format */
            if (!DrgVerifyRMF(dragitem, "DRM_OS2FILE", NULL))
               accept = DOR_NEVERDROP;
         }

         DrgFreeDraginfo(draginfo);

         return (MRFROM2SHORT(accept, DO_COPY));
      }

      case DM_DROP:
      {
         DRAGINFO *draginfo = (DRAGINFO *)mp1;
         USHORT cItems,i;
         DRAGITEM *dragitem;
         char buffer[2*CCHMAXPATH] = {0};
         ULONG hobj = 0;

         DrgAccessDraginfo(draginfo);
         cItems = DrgQueryDragitemCount(draginfo);

         for (i = 0; i < cItems; i++, buffer[0] = '\0')
         {
            dragitem = DrgQueryDragitemPtr(draginfo, i);

            /* Check the rendering format */
            if (DrgVerifyRMF(dragitem, "DRM_OS2FILE", NULL))
            {
               DrgQueryStrName(dragitem->hstrContainerName,CCHMAXPATH,buffer);
               DrgQueryStrName(dragitem->hstrSourceName,CCHMAXPATH,strchr(buffer,'\0'));

               hobj = WinQueryObject(buffer);
            }

            if (buffer[0])
               insertItemText(hwnd,0,LIT_END,buffer);
         }

         DrgFreeDraginfo(draginfo);

         return 0;
      }

	}

	return wpLB( hwnd, msg, mp1, mp2 );
}

void processCommand(HWND hwnd,MPARAM mp1,MPARAM mp2)
{
	switch(SHORT1FROMMP(mp1))
	{
		case PB_ADDCD:
		{
			char buffer[512];
			USHORT item;

			getText(hwnd,EF_TRACK,buffer,sizeof(buffer));
			if(buffer[0])
			{
				item = insertItemText(hwnd, LB_TRACK, 0, buffer);
				selectItem(hwnd, LB_TRACK, item);
				setText(hwnd, EF_TRACK,"");
			}

			break;
		}

		case PB_DELETECD:
		{
			SHORT item;

			item = getSelectItem(hwnd,LB_TRACK,LIT_FIRST);

			deleteItem(hwnd, LB_TRACK, item);
			selectItem(hwnd, LB_TRACK, item);

			break;
		}

      case PB_CLEARCD:
      {
         deleteAllItems(hwnd,LB_TRACK);
         break;
      }

      case PB_FILL:
		{
			char buffer[512];
			USHORT item;
			int from, to;

			getText(hwnd,EF_FROM,buffer,sizeof(buffer));
			from = atoi(buffer);

			getText(hwnd,EF_TO,buffer,sizeof(buffer));
			to = atoi(buffer);

			if(from && to)
			{
				int i;
				WinSendDlgItemMsg(hwnd, LB_TRACK, LM_DELETEALL, 0, 0);
				for(i = from; i <= to; i++)
					insertItemText(hwnd, LB_TRACK, LIT_END, _itoa(i,buffer,10));
			}
			break;
		}

		case PB_ADDWAV:
		{
			int i;
			FILEDLG filedlginfo = {0};
			filedlginfo.cbSize = sizeof(FILEDLG);
			filedlginfo.fl = FDS_CENTER | FDS_OPEN_DIALOG | FDS_MULTIPLESEL;
			filedlginfo.pszTitle = "Add WAV Files";
			strcpy(filedlginfo.szFullFile,"*.WAV");
			filedlginfo.pszOKButton = "Add";

			WinFileDlg(HWND_DESKTOP,hwnd,&filedlginfo);

			for(i = 0; i < filedlginfo.ulFQFCount ; i++)
				insertItemText(hwnd, LB_WAV, LIT_END, *filedlginfo.papszFQFilename[i]);

			WinFreeFileDlgList(filedlginfo.papszFQFilename);
			break;
		}

		case PB_DELETEWAV:
		{
			SHORT item;

			item = getSelectItem(hwnd,LB_WAV,LIT_FIRST);

			deleteItem(hwnd, LB_WAV, item);
			selectItem(hwnd, LB_WAV, item);

			break;
		}

      case PB_CLEARWAV:
      {
         deleteAllItems(hwnd,LB_WAV);
         break;
      }

		case PB_CONVERT:
         disable(hwnd,PB_CONVERT);
         enable(hwnd,PB_STOP);
			beginConverter(hwnd);
			break;

      case PB_STOP:
         DosWriteQueue(que,CD2MP3_STOP,0,NULL,0);
         break;

      case CD2MP3_STOPPED:
         enable(hwnd,PB_CONVERT);
         disable(hwnd,PB_STOP);
         break;
	}
}

void processControl(HWND hwnd,MPARAM mp1,MPARAM mp2)
{
/*
	switch(SHORT1FROMMP(mp1))
	{

	} */

	return;
}

void loadIni(HWND hwnd)
{
   char buffer[512];
   char *list;
   HINI inifile;
   int listsize;

   inifile = openProfile(INIFILE);

   if(readProfile(inifile,"CD","Grabber",buffer,sizeof(buffer), TRUE))
      setText(WinWindowFromID(hwnd, CB_GRABBER), CBID_EDIT, buffer);
   if(readProfile(inifile,"CD","Drive",buffer,sizeof(buffer), TRUE))
      setText(WinWindowFromID(hwnd, CB_DRIVE), CBID_EDIT, buffer);
   if(readProfile(inifile,"CD","Basename",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_BASENAME, buffer);
   if(readProfile(inifile,"CD","TempDir",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_TEMPDIR, buffer);
   if(readProfile(inifile,"CD","Track",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_TRACK, buffer);
   if(readProfile(inifile,"CD","From",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_FROM, buffer);
   if(readProfile(inifile,"CD","To",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_TO, buffer);
   if(readProfile(inifile,"CD","Custom",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_CUSTOMCD, buffer);

   listsize = getProfileSize(inifile,"CD","TrackList");
   list = alloca(listsize);

   if(readProfile(inifile,"CD","TrackList",list, listsize, FALSE))
   {
      char *listpos = list;

      while(*listpos)
      {
         insertItemText(hwnd, LB_TRACK, LIT_END, listpos);
         listpos = strchr(listpos,0)+1;
      }
	}

   if(readProfile(inifile,"WAV","Wav",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_WAV, buffer);

   listsize = getProfileSize(inifile,"WAV","WavList");
   list = alloca(listsize);

   if(readProfile(inifile,"WAV","WavList",list, listsize, FALSE))
   {
      char *listpos = list;

      while(*listpos)
      {
         insertItemText(hwnd, LB_WAV, LIT_END, listpos);
         listpos = strchr(listpos,0)+1;
      }
	}

   if(readProfile(inifile,"MP3","Encoder",buffer,sizeof(buffer), TRUE))
      setText(WinWindowFromID(hwnd, CB_ENCODER), CBID_EDIT, buffer);
   if(readProfile(inifile,"MP3","Bitrate",buffer,sizeof(buffer), TRUE))
      setText(WinWindowFromID(hwnd, CB_BITRATE), CBID_EDIT, buffer);
   if(readProfile(inifile,"MP3","HighQuality",buffer,1, FALSE))
      setCheck(hwnd, CB_HQ, *buffer);
   if(readProfile(inifile,"MP3","MP3Dir",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_MP3DIR, buffer);
   if(readProfile(inifile,"MP3","Custom",buffer,sizeof(buffer), TRUE))
      setText(hwnd, EF_CUSTOMMP3, buffer);

   closeProfile(inifile);
}

void saveIni(HWND hwnd)
{
   char buffer[512];
   HINI inifile;
   int listcount;
   char *listpos, *list;
   int i;
   SHORT listsize;

   inifile = openProfile(INIFILE);

   getText(WinWindowFromID(hwnd, CB_GRABBER), CBID_EDIT, buffer, sizeof(buffer));
   writeProfile(inifile,"CD","Grabber", buffer,0);
   getText(WinWindowFromID(hwnd, CB_DRIVE), CBID_EDIT, buffer, sizeof(buffer));
   writeProfile(inifile,"CD","Drive", buffer,0);
   getText(hwnd, EF_BASENAME, buffer, sizeof(buffer));
   writeProfile(inifile,"CD","Basename", buffer,0);
   getText(hwnd, EF_TEMPDIR, buffer, sizeof(buffer));
   writeProfile(inifile,"CD","TempDir", buffer,0);
   getText(hwnd, EF_TRACK, buffer, sizeof(buffer));
   writeProfile(inifile,"CD","Track", buffer,0);
   getText(hwnd, EF_FROM, buffer, sizeof(buffer));
   writeProfile(inifile,"CD","From", buffer,0);
   getText(hwnd, EF_TO, buffer, sizeof(buffer));
   writeProfile(inifile,"CD","To",buffer,0);
   getText(hwnd, EF_CUSTOMCD, buffer, sizeof(buffer));
   writeProfile(inifile,"CD","Custom", buffer,0);

   list = NULL;
   listsize = 0;
   listcount = 0;

   listcount = getItemCount(hwnd, LB_TRACK);
   if(listcount)
	{
      listsize = 0;
      for(i = 0; i < listcount; i++)
         listsize += (getItemTextSize(hwnd, LB_TRACK, i) + 1);

      listsize++;
      list = listpos = alloca(listsize);
      memset(list,0,listsize);

      for(i = 0; i < listcount; i++)
         listpos += (getItemText(hwnd, LB_TRACK, i, listpos, getItemTextSize(hwnd, LB_TRACK, i) + 1) + 1);
	}
   writeProfile(inifile,"CD","TrackList", list, listsize);

   getText(hwnd, EF_WAV, buffer, sizeof(buffer));
   writeProfile(inifile,"WAV","Wav", buffer,0);

   list = NULL;
   listsize = 0;
   listcount = 0;

   listcount = getItemCount(hwnd, LB_WAV);
   if(listcount)
	{
      listsize = 0;
      for(i = 0; i < listcount; i++)
         listsize += (getItemTextSize(hwnd, LB_WAV, i) + 1);

      listsize++;
      list = listpos = alloca(listsize);
      memset(list,0,listsize);

      for(i = 0; i < listcount; i++)
         listpos += (getItemText(hwnd, LB_WAV, i, listpos, getItemTextSize(hwnd, LB_WAV, i) + 1) + 1);
	}
   writeProfile(inifile,"WAV","WavList", list, listsize);

   getText(WinWindowFromID(hwnd, CB_ENCODER), CBID_EDIT, buffer, sizeof(buffer));
   writeProfile(inifile,"MP3","Encoder", buffer,0);
   getText(WinWindowFromID(hwnd, CB_BITRATE), CBID_EDIT, buffer, sizeof(buffer));
   writeProfile(inifile,"MP3","Bitrate", buffer,0);
   *buffer = getCheck(hwnd, CB_HQ);
   writeProfile(inifile,"MP3","HighQuality", buffer, 1);
   getText(hwnd, EF_MP3DIR, buffer, sizeof(buffer));
   writeProfile(inifile,"MP3","MP3Dir", buffer,0);
   getText(hwnd, EF_CUSTOMMP3, buffer, sizeof(buffer));
   writeProfile(inifile,"MP3","Custom", buffer,0);

   closeProfile(inifile);
}


/* removes comments starting with # */
char *uncomment(char *something)
{
	int source = 0;
	BOOL inquotes = FALSE;

	while(something[source])
	{
		if(something[source] == '\"')
			inquotes = !inquotes;
      else if(something[source] == '#' && !inquotes)
		{
			something[source] = 0;
			break;
		}
		source++;
	}

	return something;
}

/* remove leading and trailing spaces and quotes */
char *strip(char *something)
{
   int i,e;
   char *pos = something;

   while (*pos == ' ' || *pos == '\t' || *pos == '\n') pos++;
   i = strlen(pos) - 1;
   for (;i>0;i--) if (pos[i] != ' ' && pos[i] != '\t' && pos[i] != '\n') break;
   if(*pos == '\"' && pos[i] == '\"' )
   {
      pos++;
      i -= 2;
   }
   for(e = 0; e < i+1; e++)
      something[e] = pos[e];
   something[e] = 0;
   return(something);
}

BOOL loadConfig(char *file, ENCODER **encoders, int *countEncoders,
                            GRABBER **grabbers, int *countGrabbers)
{
	FILE *config;
	config = fopen(file,"r");

	if(config)
	{
		char buffer[512], param[256], value[256], *comment;
      int i, e;

		i = 0;
      e = 0;
		while(fgets(buffer,sizeof(buffer),config))
		{
         uncomment(buffer);
         sscanf(buffer,"%[^=]=%[^=]",param,value);
			strip(param);

         if(!stricmp(param,"encoderid")) i++;
         if(!stricmp(param,"grabberid")) e++;
		}

      *encoders = (ENCODER *) calloc(i, sizeof(ENCODER));
      *grabbers = (GRABBER *) calloc(e, sizeof(GRABBER));

		rewind(config);

		i = -1;
      e = -1;
		while(fgets(buffer,sizeof(buffer),config))
		{
         uncomment(buffer);
         sscanf(buffer,"%[^=]=%[^=]",param,value);
			strip(param);
			strip(value);

         if(!stricmp(param,"encoderid"))
			{
				i++;
				strcpy((*encoders)[i].id, value);
			}
			else if(i >=0)
			{
            if(!stricmp(param,"encoderexe"))
					strcpy((*encoders)[i].exe, value);
            else if(!stricmp(param,"encodertype"))
				{
					if(!stricmp(value,"win32os2"))
						(*encoders)[i].type = WIN32OS2;
					else if(!stricmp(value,"vio"))
						(*encoders)[i].type = VIO;
					else if(!stricmp(value,"vdm"))
						(*encoders)[i].type = VDM;
				}
            else if(!stricmp(param,"encoderin"))
					strcpy((*encoders)[i].input, value);
            else if(!stricmp(param,"encoderout"))
					strcpy((*encoders)[i].output, value);
            else if(!stricmp(param,"encoderlq"))
					strcpy((*encoders)[i].lq, value);
            else if(!stricmp(param,"encoderhq"))
					strcpy((*encoders)[i].hq, value);
            else if(!stricmp(param,"encoderbefore"))
               strcpy((*encoders)[i].before, value);
            else if(!stricmp(param,"encoderafter"))
               strcpy((*encoders)[i].after, value);
            else if(!stricmp(param,"encoderbitrate"))
					strcpy((*encoders)[i].bitrate, value);
            else if(!stricmp(param,"encoderbrmath"))
					(*encoders)[i].bitrateMath = atoi(value);
            else if(!stricmp(param,"encoderbrpc"))
				{
					if(!stricmp(value,"true"))
						(*encoders)[i].bitratePerChannel = TRUE;
					else
						(*encoders)[i].bitratePerChannel = FALSE;
				}
            else if(!stricmp(param,"encoderacceptsoutput"))
				{
					if(!stricmp(value,"true"))
                  (*encoders)[i].acceptsOutput = TRUE;
					else
                  (*encoders)[i].acceptsOutput = FALSE;
            }
         }

         if(!stricmp(param,"grabberid"))
			{
            e++;
            strcpy((*grabbers)[e].id, value);
			}
         else if(e >=0)
			{
            if(!stricmp(param,"grabberexe"))
               strcpy((*grabbers)[e].exe, value);
            else if(!stricmp(param,"grabbertype"))
				{
					if(!stricmp(value,"win32os2"))
                  (*grabbers)[e].type = WIN32OS2;
					else if(!stricmp(value,"vio"))
                  (*grabbers)[e].type = VIO;
					else if(!stricmp(value,"vdm"))
                  (*grabbers)[e].type = VDM;
				}
            else if(!stricmp(param,"grabberin"))
               strcpy((*grabbers)[e].input, value);
            else if(!stricmp(param,"grabberout"))
               strcpy((*grabbers)[e].output, value);
            else if(!stricmp(param,"grabbermangling"))
               strcpy((*grabbers)[e].mangling, value);
            else if(!stricmp(param,"grabberbefore"))
               strcpy((*grabbers)[e].before, value);
            else if(!stricmp(param,"grabberafter"))
               strcpy((*grabbers)[e].after, value);
            else if(!stricmp(param,"grabberacceptsoutput"))
				{
					if(!stricmp(value,"true"))
                  (*grabbers)[e].acceptsOutput = TRUE;
					else
                  (*grabbers)[e].acceptsOutput = FALSE;
				}
            else if(!stricmp(param,"grabbernodrive"))
				{
					if(!stricmp(value,"true"))
                  (*grabbers)[e].noDrive = TRUE;
					else
                  (*grabbers)[e].noDrive = FALSE;
				}
         }
		}
      *countEncoders = i+1;
      *countGrabbers = e+1;

		fclose(config);
      return TRUE;
	}
   return FALSE;
}

void processInitdlg(HWND hwnd,MPARAM mp1,MPARAM mp2)
{
	ULONG rc, i;
	HFILE CDDevice;
	ULONG action;
	ULONG len;
	struct
	{
		USHORT CountCD;
		USHORT FirstCD;
	} CDInfo;

	PTIB ptib;
	PPIB ppib;

	DosGetInfoBlocks(&ptib, &ppib);
	sprintf(quename,"\\QUEUES\\CD2MP3PM_PID%d.QUE",ppib->pib_ulpid);
	DosCreateQueue(&que,QUE_FIFO,quename);
	DosCreateEventSem(NULL,&quesem,0,FALSE);


	wpEF = WinSubclassWindow(WinWindowFromID(hwnd,EF_TRACK),(PFNWP)wpEFTrack);
	wpLB = WinSubclassWindow(WinWindowFromID(hwnd,LB_TRACK),(PFNWP)wpLBTrack);

	wpEF = WinSubclassWindow(WinWindowFromID(hwnd,EF_WAV),(PFNWP)wpEFWav);
	wpLB = WinSubclassWindow(WinWindowFromID(hwnd,LB_WAV),(PFNWP)wpLBWav);

	insertItemText(hwnd,CB_BITRATE,LIT_END,"Default");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"8");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"16");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"24");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"32");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"40");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"48");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"56");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"64");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"80");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"96");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"112");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"128");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"144");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"160");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"192");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"224");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"256");
	insertItemText(hwnd,CB_BITRATE,LIT_END,"320");

	selectItem(hwnd,CB_BITRATE,12);


   loadConfig(CFGFILE, &encoders, &countEncoders, &grabbers, &countGrabbers);
	for(i = 0; i < countEncoders; i++)
		insertItemText(hwnd,CB_ENCODER,LIT_END,encoders[i].id);
	selectItem(hwnd,CB_ENCODER,0);
   for(i = 0; i < countGrabbers; i++)
      insertItemText(hwnd,CB_GRABBER,LIT_END,grabbers[i].id);
   selectItem(hwnd,CB_GRABBER,0);


   setText(hwnd, EF_BASENAME, "Track");

   setCheck(hwnd,CB_LOWPRIO,TRUE);

	/* wohw, this is too powerful, need cooling */

	len = sizeof(CDInfo);
	if(!DosOpen("\\DEV\\CD-ROM2$", &CDDevice, &action, 0,
					FILE_NORMAL, OPEN_ACTION_OPEN_IF_EXISTS,
					OPEN_SHARE_DENYNONE | OPEN_ACCESS_READONLY, NULL) &&

		!DosDevIOCtl(CDDevice, 0x82, 0x60, NULL, 0, NULL, &CDInfo, len, &len))
	{
		for(i = 0; i < CDInfo.CountCD; i++)
		{
			char driveLetter[3] = { (char) ('A' + CDInfo.FirstCD + i), ':', 0};
			insertItemText(hwnd,CB_DRIVE,LIT_END,driveLetter);
		}
	}
   selectItem(hwnd,CB_DRIVE,0);

   loadIni(hwnd);

   enable(hwnd,PB_CONVERT);
   disable(hwnd,PB_STOP);
}

RECTL errorLocation;

MRESULT EXPENTRY wpMain(HWND hwnd,ULONG msg,MPARAM mp1,MPARAM mp2)
{
	switch (msg)
	{
		case WM_INITDLG:
			processInitdlg(hwnd,mp1,mp2); return 0;
		case WM_COMMAND:
			processCommand(hwnd,mp1,mp2); return 0;
		case WM_CONTROL:
			processControl(hwnd,mp1,mp2); return 0;
#if 0
      case WM_ERASEBACKGROUND:
      {
         RECTL *rect = PVOIDFROMMP(mp2);
         POINTL pos;
         HBITMAP hbm;
         BITMAPINFOHEADER info;

         hbm = GpiLoadBitmap(HWNDFROMMP(mp1),0,BM_BACKGROUND,0,0);
         info.cbFix = sizeof(info);
         if(GpiQueryBitmapParameters(hbm,&info))
         {
            pos.x = 0;
            while(pos.x < rect->xRight)
            {
               pos.y = 0;
               while(pos.y < rect->yTop)
               {
                  WinDrawBitmap(HWNDFROMMP(mp1), hbm, NULL, &pos, 0, 0, DBM_NORMAL);
                  pos.y += info.cy;
               }
               pos.x += info.cx;
            }
         }
         return 0;
      }
#endif
      case WM_PAINT:
         WinDefDlgProc( hwnd, msg, mp1, mp2 );
         paintError();
         return 0;
      case WM_BUTTON1CLICK:
         if( (SHORT1FROMMP(mp1) > errorLocation.xLeft) &&
             (SHORT1FROMMP(mp1) < errorLocation.xRight) &&
             (SHORT2FROMMP(mp1) > errorLocation.yBottom) &&
             (SHORT2FROMMP(mp1) < errorLocation.yTop) )
           eraseError();
         break;

		case WM_CHAR:
			if(SHORT2FROMMP(mp2) == VK_ESC)
				return 0;
			else
				break;
		case WM_CLOSE:
			DosCloseQueue(que);
			DosCloseEventSem(quesem);
			free(encoders);
         free(grabbers);
         saveIni(hwnd);
			WinPostMsg(hwnd,WM_QUIT,0,0);
			return 0;
	}

	return WinDefDlgProc( hwnd, msg, mp1, mp2 );
}

int main(int argc, char *argv[])
{
   if(initPM() && (mainHwnd = loadDlg(HWND_DESKTOP, wpMain, DLG_CD2MP3)))
   {
      errorLocation.xLeft = 15;
      errorLocation.xRight = 400;
      errorLocation.yBottom = 10;
      errorLocation.yTop = 25;
      initError(mainHwnd,errorLocation);

      if(!isWarpSans())
         WinSetPresParam(mainHwnd, PP_FONTNAMESIZE, 7, "8.Helv");

      loadPosition(mainHwnd, INIFILE);

      runPM();

      savePosition(mainHwnd, INIFILE);

      closePM();

      return 0;
   }

   return 1;
}
