/* PM stuff (C) 1998 Samuel Audet <guardia@cam.org> */

#define INCL_PM
#include <os2.h>
#include <stdarg.h>
#include <stdio.h>
#include <string.h>

#include "prfsam.h"

HMQ hmq;
HAB hab;

HWND createClientFrame(HWND *hwndClient, char *classname,
				 ULONG *frameFlags, PFNWP winproc, char *title)
{
	HWND HwndFrame;

	WinRegisterClass( hab, classname, winproc,
						CS_CLIPCHILDREN | CS_SIZEREDRAW, 0 );

	HwndFrame = WinCreateStdWindow (HWND_DESKTOP, 0, frameFlags, classname,
											title, 0, 0, 1, hwndClient);

	return HwndFrame;
}

void loadPosition(HWND hwnd, char *inifilename)
{
	SWP pos;
	HINI inifile;
	ULONG state;

	inifile = openProfile(inifilename);

	/* get window position from INI file */
	if(inifile)
	{
      if( readProfile(inifile,"Position","state",&state, sizeof(state), FALSE) &&
			 readProfile(inifile,"Position","x",&pos.x, sizeof(pos.x), FALSE) &&
          readProfile(inifile,"Position","y",&pos.y, sizeof(pos.y), FALSE) &&
			 readProfile(inifile,"Position","cx",&pos.cx, sizeof(pos.cx), FALSE) &&
			 readProfile(inifile,"Position","cy",&pos.cy, sizeof(pos.cy), FALSE) )

         WinSetWindowPos( hwnd, NULLHANDLE,
								  pos.x, pos.y, pos.cx, pos.cy,
								  SWP_SIZE | SWP_MOVE | SWP_SHOW | state );
      else

         WinSetWindowPos( hwnd, NULLHANDLE,
                          0, 0, 0, 0,
                          SWP_SHOW);


		closeProfile(inifile);
	}
}

void savePosition(HWND hwnd, char *inifilename)
{
	SWP pos;
	HINI inifile;
	ULONG state;

	inifile = openProfile(inifilename);

	/* save window position in INI file */
	if (inifile)
	{
		if (WinQueryWindowPos(hwnd, &pos))
		{
			state = 0;
			if (pos.fl & SWP_MINIMIZE)
			{
				pos.x = (LONG) WinQueryWindowUShort(hwnd, QWS_XRESTORE);
				pos.y = (LONG) WinQueryWindowUShort(hwnd, QWS_YRESTORE);
				pos.cx = (LONG) WinQueryWindowUShort(hwnd, QWS_CXRESTORE);
				pos.cy = (LONG) WinQueryWindowUShort(hwnd, QWS_CYRESTORE);
				state = SWP_MINIMIZE;
			}
			else if (pos.fl & SWP_MAXIMIZE)
			{
				pos.x = (LONG) WinQueryWindowUShort(hwnd, QWS_XRESTORE);
				pos.y = (LONG) WinQueryWindowUShort(hwnd, QWS_YRESTORE);
				pos.cx = (LONG) WinQueryWindowUShort(hwnd, QWS_CXRESTORE);
				pos.cy = (LONG) WinQueryWindowUShort(hwnd, QWS_CYRESTORE);
				state = SWP_MAXIMIZE;
			}

			writeProfile(inifile,"Position","state", &state, sizeof(state));
			writeProfile(inifile,"Position","x", &pos.x, sizeof(pos.x));
			writeProfile(inifile,"Position","y", &pos.y, sizeof(pos.y));
			writeProfile(inifile,"Position","cx", &pos.cx, sizeof(pos.cx));
			writeProfile(inifile,"Position","cy", &pos.cy, sizeof(pos.cy));
		}
		closeProfile(inifile);
	}
}

/* error display handling */
char errormsg[256]; /* error message */
int errornum;		  /* error counter */
RECTL location;	  /* error message location in window hwnderror */
HWND hwnderror = 0;

void initError(HWND sethwnderror, RECTL setlocation)
{
	errornum = 1;
	errormsg[0] = 0;
	location = setlocation;
	hwnderror = sethwnderror;
}

void _System updateError(char *fmt, ...)
{
	va_list args;

	if(!hwnderror) return;

	sprintf(errormsg,"%d. ",errornum++);
	va_start(args, fmt);
	vsprintf(strchr(errormsg,0),fmt,args);
	va_end(args);

	WinInvalidateRect( hwnderror, &location, FALSE );
}

/* put this in WM_PAINT of hwnderror */
void paintError(void)
{
	HPS hps;

	if(!hwnderror) return;

/* BeginPaint doesn't work!!??   hps = WinBeginPaint(hwnderror,0,&location); */
   hps = WinGetPS(hwnderror);
//   WinFillRect(hps, &location, SYSCLR_FIELDBACKGROUND);
	if (errormsg[0] != '\0')
		WinDrawText(hps, -1, errormsg, &location, CLR_RED, BM_LEAVEALONE, 0);
/*   WinEndPaint(hps); */
   WinReleasePS(hwnderror);
}

/* idea: put this in your WM_BUTTON1CLICK and check if the user clicked
	on the error, he probably wants to remove it:

	if( (SHORT1FROMMP(mp1) > location.xLeft) &&
		 (SHORT1FROMMP(mp1) < location.xRight) &&
		 (SHORT2FROMMP(mp1) > location.yBottom) &&
		 (SHORT2FROMMP(mp1) < location.yTop) )
	  eraseError();
*/
void eraseError(void)
{
	if(!hwnderror) return;

	errormsg[0] = 0;
	WinInvalidateRect( hwnderror, &location, FALSE );
}

