HWND createClientFrame(HWND *hwndClient, char *classname,
				 ULONG *frameFlags, PFNWP winproc, char *title);
void loadPosition(HWND hwnd, char *inifilename);
void savePosition(HWND hwnd, char *inifilename);

void _System updateError(char *fmt, ...);
void initError(HWND sethwnderror, RECTL setlocation);
void paintError(void);
void eraseError(void);

extern HMQ hmq;
extern HAB hab;

_Inline BOOL initPM(void)
{
	hmq = hab = 0;

	hab = WinInitialize(0);
	if(hab)
	  hmq = WinCreateMsgQueue(hab, 0);
	if(hmq)
	  return TRUE;

	return FALSE;
}

_Inline void runPM(void)
{
	QMSG qmsg;

	while( WinGetMsg( hab, &qmsg, 0L, 0, 0 ) )
		WinDispatchMsg( hab, &qmsg );
}

_Inline void closePM(void)
{
   WinDestroyMsgQueue( hmq );
   WinTerminate( hab );
}

_Inline BOOL isWarpSans(void)
{
	LONG fontcounter = 0;
	HPS hps;
	BOOL rc;

	hps = WinGetPS(HWND_DESKTOP);
	rc = GpiQueryFonts(hps, QF_PUBLIC,"WarpSans", &fontcounter, 0, NULL);
	WinReleasePS(hps);
	return rc;
}

_Inline HWND loadDlg(HWND parent, PFNWP winproc, ULONG id)
{
   return WinLoadDlg(parent, parent, winproc, 0, id, NULL);
}

_Inline USHORT getCheck(HWND hwnd, LONG id)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd, id, BM_QUERYCHECK, 0, 0));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd, BM_QUERYCHECK, 0, 0));
}

_Inline USHORT setCheck(HWND hwnd, LONG id, USHORT state)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd, id, BM_SETCHECK, MPFROMSHORT(state), 0));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd, BM_SETCHECK, MPFROMSHORT(state), 0));
}

_Inline ULONG getText(HWND hwnd, LONG id, char *buffer, LONG size)
{
   if(id)
      return WinQueryDlgItemText(hwnd,id,size,buffer);
   else
      return WinQueryWindowText(hwnd,size,buffer);
}

_Inline BOOL setText(HWND hwnd, LONG id, char *buffer)
{
   if(id)
      return WinSetDlgItemText(hwnd, id, buffer);
   else
      return WinSetWindowText(hwnd, buffer);
}

/* listbox */

_Inline SHORT getItemCount(HWND hwnd, LONG id)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd,id,LM_QUERYITEMCOUNT,0,0));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd,LM_QUERYITEMCOUNT,0,0));
}

_Inline SHORT getItemText(HWND hwnd, LONG id, SHORT item, char *buffer, LONG size)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd,id,LM_QUERYITEMTEXT,MPFROM2SHORT(item,size),MPFROMP(buffer)));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd,LM_QUERYITEMTEXT,MPFROM2SHORT(item,size),MPFROMP(buffer)));
}

_Inline SHORT getItemTextSize(HWND hwnd, LONG id, SHORT item)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd,id,LM_QUERYITEMTEXTLENGTH,MPFROMSHORT(item),0));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd,LM_QUERYITEMTEXTLENGTH,MPFROMSHORT(item),0));
}

_Inline SHORT insertItemText(HWND hwnd, LONG id, SHORT item, char *buffer)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd, id, LM_INSERTITEM, MPFROMSHORT(item), MPFROMP(buffer)));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd, LM_INSERTITEM, MPFROMSHORT(item), MPFROMP(buffer)));
}

_Inline SHORT deleteItem(HWND hwnd, LONG id, SHORT item)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd,id, LM_DELETEITEM, MPFROMSHORT(item),0));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd, LM_DELETEITEM, MPFROMSHORT(item),0));
}

_Inline SHORT deleteAllItems(HWND hwnd, LONG id)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd,id, LM_DELETEALL, 0,0));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd, LM_DELETEALL, 0,0));
}

_Inline SHORT selectItem(HWND hwnd, LONG id, SHORT item)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd,id, LM_SELECTITEM, MPFROMSHORT(item),MPFROMLONG(TRUE)));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd, LM_SELECTITEM, MPFROMSHORT(item),MPFROMLONG(TRUE)));
}

_Inline SHORT deSelectItem(HWND hwnd, LONG id, SHORT item)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd,id, LM_SELECTITEM, MPFROMSHORT(item),MPFROMLONG(FALSE)));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd, LM_SELECTITEM, MPFROMSHORT(item),MPFROMLONG(FALSE)));
}

_Inline SHORT getSelectItem(HWND hwnd, LONG id, SHORT item)
{
   if(id)
      return SHORT1FROMMR(WinSendDlgItemMsg(hwnd,id, LM_QUERYSELECTION, MPFROMSHORT(item),0));
   else
      return SHORT1FROMMR(WinSendMsg(hwnd, LM_QUERYSELECTION, MPFROMSHORT(item),0));
}

_Inline BOOL enable(HWND hwnd, LONG id)
{
   if(id)
      return WinEnableWindow(WinWindowFromID(hwnd,id), TRUE);
   else
      return WinEnableWindow(hwnd, TRUE);
}

_Inline BOOL disable(HWND hwnd, LONG id)
{
   if(id)
      return WinEnableWindow(WinWindowFromID(hwnd,id), FALSE);
   else
      return WinEnableWindow(hwnd, FALSE);
}
