/* Spawner for CD2MP3 0.90 (C) 1998 Samuel Audet <guardia@cam.org> */

#define INCL_PM
#define INCL_DOS
#define INCL_DOSERRORS
#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "pmsam.h"
#include "cd2mp3pm.h"

/* wavfile needed for Win32-OS/2 kludge */
BOOL doWin32OS2(char *program, char *cmdline, char *wavfile, BOOL lowprio,
                HQUEUE que, HEV quesem, char *quename)
{
   STARTDATA startdata;
   ULONG idSession;
   PID childpid;
   SWBLOCK *switchlist = NULL;
   HAB hab = WinQueryAnchorBlock(HWND_DESKTOP);
   ULONG count,buffersize;
   BOOL finished;
   APIRET rc;
   BOOL success = TRUE;
   PID savePID;

   struct
   {
      USHORT SessionID;
      USHORT rc;
   } *termdata = NULL;
   REQUESTDATA request;
   ULONG length;
   char prio;

   memset(&startdata,0,sizeof(startdata));
   startdata.Length = sizeof(startdata);
  /* startdata.Related = SSF_RELATED_CHILD; */
   startdata.SessionType = SSF_TYPE_PM;
   startdata.PgmName = program;
   startdata.PgmInputs = cmdline;
   startdata.Environment = "NOWIN32LOG=anything\0";
   startdata.InheritOpt = 1;

   DosPurgeQueue(que);

   if(lowprio)
      DosSetPriority(PRTYS_PROCESS, PRTYC_IDLETIME, 0, 0);
   rc = DosStartSession(&startdata,&idSession,&childpid);
   if(lowprio)
      DosSetPriority(PRTYS_PROCESS, PRTYC_REGULAR, 0, 0);

   if(rc != NO_ERROR && rc != ERROR_SMG_START_IN_BACKGROUND)
   {
      updateError("Could not start %s. DosStartSession rc = %d", program, rc);
      success = FALSE; goto end;
   }

   finished = FALSE;
   do
   {
      DosSleep(500);

      count = WinQuerySwitchList(hab,NULL,0);
      buffersize = count * sizeof(SWENTRY) + sizeof(ULONG);
      if(_msize(switchlist) < buffersize)
      {
         free(switchlist);
         switchlist = (PSWBLOCK) malloc(2*buffersize);
      }
      if (switchlist && count)
      {
         int i;
         count = WinQuerySwitchList(hab,switchlist,buffersize);

         /* go into all switch list items */
         for (i = 0 ; i < count ; i++)
         {
            if ( strstr(switchlist->aswentry[i].swctl.szSwtitle, program) &&
                 strstr(switchlist->aswentry[i].swctl.szSwtitle, wavfile))
            {
               savePID = switchlist->aswentry[i].swctl.idProcess;
               if(strstr(switchlist->aswentry[i].swctl.szSwtitle, "Completed:"))
               {
                  DosKillProcess(DKP_PROCESS,savePID);
                  finished = TRUE;
                  goto end;
               }
            }
         }
      }

      rc = DosReadQueue(que,&request,&length,(void **)&termdata,0,DCWW_NOWAIT,&prio,quesem);

      if(rc != ERROR_QUE_EMPTY)
         switch(request.ulData)
         {
            case CD2MP3_STOP:

               DosKillProcess(DKP_PROCESS,savePID);
                  updateError("%s could not be killed, sorry.",program);

               success = FALSE;
               goto end;

            default:

               updateError("Error occured in Queue, aborting MP3 encoding.");
               success = FALSE;
               goto end;
         }

   } while(!finished);

end:

   DosFreeMem(termdata);
   free(switchlist);

   return success;
}

BOOL doNormal(char *program, char *cmdline, USHORT sessionType, BOOL lowprio,
              HQUEUE que, HEV quesem, char *quename)
{
   STARTDATA startdata;
   ULONG idSession;
   PID childpid;
   char title[1024];
   APIRET rc;
   BOOL success = TRUE;
   struct
   {
      USHORT SessionID;
      USHORT rc;
   } *termdata = NULL;
   REQUESTDATA request;
   ULONG length;
   ULONG resetcount;
   char prio;

   strcpy(title, program);
   strcat(title, " ");
   strcat(title, cmdline);

   memset(&startdata,0,sizeof(startdata));
   startdata.Length = sizeof(startdata);
   startdata.Related = SSF_RELATED_CHILD;
   startdata.SessionType = sessionType;
//   startdata.Environment = "VARIABLE=anything\0";
   startdata.PgmName = program;
   startdata.PgmInputs = cmdline;
   startdata.PgmTitle = title;
   startdata.InheritOpt = 1;
   startdata.TermQ = quename;

   DosPurgeQueue(que);
   DosResetEventSem(quesem, &resetcount);

   if(lowprio)
      DosSetPriority(PRTYS_PROCESS, PRTYC_IDLETIME, 0, 0);
   rc = DosStartSession(&startdata,&idSession,&childpid);
   if(lowprio)
      DosSetPriority(PRTYS_PROCESS, PRTYC_REGULAR, 0, 0);

   if(rc != NO_ERROR && rc != ERROR_SMG_START_IN_BACKGROUND)
   {
      updateError("Could not start %s. DosStartSession rc = %d", program, rc);
      success = FALSE; goto end;
   }

   rc = DosReadQueue(que,&request,&length,(void **)&termdata,0,DCWW_WAIT,&prio,quesem);

   switch(request.ulData)
   {
      case 0:

         if(termdata->SessionID == idSession)
         {
            if(termdata->rc != 0)
            {
               updateError("%s returned with errorlevel %d, aborting MP3 encoding.",program, termdata->rc);
               success = FALSE;
            }
         }
         else
         {
            updateError("Error occured in Queue, aborting MP3 encoding.");
            success = FALSE;
         }

         break;

      case CD2MP3_STOP:

         if(DosKillProcess(1,childpid))
            updateError("%s could not be killed, sorry.",program);

         success = FALSE;
         break;

      default:

         updateError("Error occured in Queue, aborting MP3 encoding.");
         success = FALSE;
         break;
   }

end:

   DosFreeMem(termdata);

   return success;
}
