/* CD3MP3 0.90 (C) 1998 Samuel Audet <guardia@cam.org> */

#define INCL_PM
#define INCL_DOS
#define INCL_DOSERRORS
#include <os2.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>

#include "pmsam.h"
#include "cd2mp3pm.h"
#include "spawner.h"
#include "wavcheck.h"

BOOL wav2mp3(char *wavfile, char *mp3dir, int bitrate, BOOL hq, BOOL lowprio,
				 ENCODER *encoder, char *custom, HQUEUE que, HEV quesem, char *quename)
{
	char mp3file[512];
#ifdef LFN_HACK
	char sfnwavfile[512];
	char sfnmp3file[512];
#endif
	char *wavname,*dot;
	char cmdline[1024] = {0};
	RIFF RIFFfile;

	strcpy(mp3file, mp3dir);
	wavname = strrchr(wavfile, '\\');
	if(wavname == NULL)
		wavname = wavfile;
	else
		wavname++;
	strcat(mp3file,wavname);
	dot = strrchr(mp3file,'.');
	if(dot != NULL) *dot = 0;
	strcat(mp3file,".mp3");

	/* building the command line */

	strcpy(cmdline, encoder->before);
	strcat(cmdline, " ");

#ifdef LFN_HACK
	if(encoder->type == VDM)
	{
		char *backslash;

		if(wavfile[1] == ':')
		{
			sfnwavfile[0] = wavfile[0];
			sfnwavfile[1] = ':';
			sfnwavfile[2] = '\\';
		}
		else
		{
			sfnwavfile[0] = '\\';
			sfnwavfile[1] = 0;
		}
		strcat(sfnwavfile,"somelfn.wav");

		if(rename(wavfile, sfnwavfile))
		{
			updateError("Rename of %s to %s unsuccessful.", wavfile, sfnwavfile);
			return FALSE;
		}

		if(mp3file[1] == ':')
		{
			sfnmp3file[0] = mp3file[0];
			sfnmp3file[1] = ':';
			sfnmp3file[2] = '\\';
		}
		else
		{
			sfnmp3file[0] = '\\';
			sfnmp3file[1] = 0;
		}
		strcat(sfnmp3file,"somelfn.mp3");

		sprintf(cmdline,"%s\"%s\" ", encoder->input, sfnwavfile);

		if(encoder->acceptsOutput)
         sprintf(strchr(cmdline,0),"%s\"%s\" ", encoder->output, sfnmp3file);
	}
	else
	{
#endif
		sprintf(cmdline,"%s\"%s\" ", encoder->input, wavfile);

		if(encoder->acceptsOutput)
         sprintf(strchr(cmdline,0),"%s\"%s\" ", encoder->output, mp3file);

#ifdef LFN_HACK
	}
#endif

	if(bitrate)
	{
		if(encoder->bitratePerChannel)
		{
			int hfile;
			hfile = open(wavfile,O_RDONLY|O_BINARY,0);
			if(hfile)
			{
				if(readRIFF(hfile,&RIFFfile))
					bitrate /= RIFFfile.WAVE.fmt.Channels;
				close(hfile);
			}
		}

		sprintf(strchr(cmdline,'\0'), "%s%d ",encoder->bitrate, bitrate*encoder->bitrateMath);
	}

	if(hq)
		strcat(cmdline,encoder->hq);
	else
		strcat(cmdline,encoder->lq);
	strcat(cmdline," ");

	strcat(cmdline,encoder->after);
	strcat(cmdline," ");
	strcat(cmdline,custom);


	switch(encoder->type)
	{
		case WIN32OS2:
			return doWin32OS2(encoder->exe, cmdline, wavfile, lowprio, que, quesem, quename);
		case VDM:
			if(doNormal(encoder->exe, cmdline, SSF_TYPE_WINDOWEDVDM, lowprio, que, quesem, quename))
			{
#ifdef LFN_HACK
				if(rename(sfnwavfile, wavfile))
				{
					updateError("Rename of %s to %s unsuccessful.", sfnwavfile, wavfile);
					return FALSE;
				}
				rename(sfnmp3file, mp3file);
				{
					updateError("Rename of %s to %s unsuccessful.", sfnmp3file, mp3file);
					return FALSE;
				}
#endif
				return TRUE;
			}
			else
				return FALSE;
		case VIO:
			return doNormal(encoder->exe, cmdline, SSF_TYPE_WINDOWABLEVIO, lowprio, que, quesem, quename);
		default:
			return FALSE;
	}
}
