/* Geez, why are WAV RIFF headers are so secret?  I got something together,
   but wow...  anyway, I hope someone will find this useful.
   - Samuel Audet <guardia@cam.org> */

/* RIFF stuff (C) 1998 Samuel Audet <guardia@cam.org> */

#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
//#include "mpg123.h"

#include "wavcheck.h"

FILE *wavfp = NULL;
RIFF RIFFfile;

void wav_struct_init(RIFF RIFFfile)
{
   RIFFfile.R1 = 'R';
   RIFFfile.I2 = 'I';
   RIFFfile.F3 = 'F';
   RIFFfile.F4 = 'F';
   RIFFfile.WAVElen = sizeof(RIFFfile.WAVE); /* + datalen */
   RIFFfile.WAVE.W1 = 'W';
   RIFFfile.WAVE.A2 = 'A';
   RIFFfile.WAVE.V3 = 'V';
   RIFFfile.WAVE.E4 = 'E';
   RIFFfile.WAVE.f5 = 'f';
   RIFFfile.WAVE.m6 = 'm';
   RIFFfile.WAVE.t7 = 't';
   RIFFfile.WAVE.space = ' ';
   RIFFfile.WAVE.fmtlen = sizeof(RIFFfile.WAVE.fmt);
   RIFFfile.WAVE.fmt.FormatTag = 1; /* standard MS PCM, and its format specific
                                   is BitsPerSample */
   RIFFfile.WAVE.d8 = 'd';
   RIFFfile.WAVE.a9 = 'a';
   RIFFfile.WAVE.t10 = 't';
   RIFFfile.WAVE.a11 = 'a';
   RIFFfile.WAVE.datalen = 0; /* we don't know yet */
}

#if 0

FILE *wav_open(struct audio_info_struct *ai, char *wavfilename)
{
   wav_struct_init(RIFFfile);

   if(ai->format == AUDIO_FORMAT_SIGNED_16)
      RIFFfile.WAVE.fmt.BitsPerSample = 16;
   else if(ai->format == AUDIO_FORMAT_UNSIGNED_8)
      RIFFfile.WAVE.fmt.BitsPerSample = 8;
   else
   {
      fprintf(stderr,"Format not supported.");
      return 0;
   }

   if(ai->rate < 0) ai->rate = 44100;

   RIFFfile.WAVE.fmt.Channels = ai->channels;
   RIFFfile.WAVE.fmt.SamplesPerSec = ai->rate;
   RIFFfile.WAVE.fmt.AvgBytesPerSec =
         RIFFfile.WAVE.fmt.Channels *
         RIFFfile.WAVE.fmt.SamplesPerSec *
         RIFFfile.WAVE.fmt.BitsPerSample / 8;
   RIFFfile.WAVE.fmt.BlockAlign =
         RIFFfile.WAVE.fmt.Channels *
         RIFFfile.WAVE.fmt.BitsPerSample / 8;

   wavfp = fopen(wavfilename,"wb+");
   if(!wavfp)
      perror("wav");
   else
      fwrite(&RIFFfile, sizeof(RIFFfile),1,wavfp);

   return wavfp;
}

int wav_write(struct audio_info_struct *ai,unsigned char *buf,int len)
{
   int temp;
   if(!wavfp) return 0;

   temp = fwrite(buf, 1, len, wavfp);

   rewind(wavfp);

   RIFFfile.WAVE.data.datalen += temp;
   RIFFfile.WAVElen += temp;
   fwrite(&RIFFfile, sizeof(RIFFfile),1,wavfp);

   fseek(wavfp,0,SEEK_END);

   return temp;
}

int wav_close(struct audio_info_struct *ai)
{
   if(!wavfp) return 0;

   return fclose(wavfp);
}

#endif

int readRIFF(int hfile, RIFF *RIFFfile)
{
   lseek(hfile, 0, SEEK_SET);
   read(hfile, &RIFFfile->R1,4);
   if(RIFFfile->R1 == 'R' && RIFFfile->I2 == 'I' && RIFFfile->F3 == 'F' && RIFFfile->F4 == 'F')
	{
      read(hfile, &RIFFfile->WAVElen,4);
      read(hfile, &RIFFfile->WAVE.W1,4);
      if(RIFFfile->WAVE.W1 == 'W' && RIFFfile->WAVE.A2 == 'A' && RIFFfile->WAVE.V3 == 'V' && RIFFfile->WAVE.E4 == 'E')
		{
			int foundfmt = 0;
			do
			{
            if(!read(hfile, &RIFFfile->WAVE.f5,4)) break;
            if(!read(hfile, &RIFFfile->WAVE.fmtlen,4)) break;
            if(RIFFfile->WAVE.f5 == 'f' && RIFFfile->WAVE.m6 == 'm' && RIFFfile->WAVE.t7 == 't' &&
               RIFFfile->WAVE.fmtlen == sizeof(RIFFfile->WAVE.fmt))
				{
               if(!read(hfile, &RIFFfile->WAVE.fmt,sizeof(RIFFfile->WAVE.fmt))) break;
               foundfmt = 1;
				}
				else
				{
					/* we skip things we don't know */
               if(lseek(hfile,RIFFfile->WAVE.fmtlen,SEEK_CUR)) break;
				}
			}
			while(!foundfmt);

			if(foundfmt)
			{
				char buffer[4];
				unsigned long length;
				/* if this is not a standard PCM sample, abort */
            if(RIFFfile->WAVE.fmt.FormatTag != 1) return 0;

				do
				{
               if(!read(hfile, &buffer,4)) break;
               if(!read(hfile, &length,4)) break;

               if(buffer[0] == 'd' && buffer[1] == 'a' && buffer[2] == 't' && buffer[3] == 'a')
					{
                  RIFFfile->WAVE.d8 = 'd';
                  RIFFfile->WAVE.a9 = 'a';
                  RIFFfile->WAVE.t10 = 't';
                  RIFFfile->WAVE.a11 = 'a';
                  RIFFfile->WAVE.datalen = length;
                  return _tell(hfile); /* tada */
					}
					else
						/* we skip things we don't know */
                  if(lseek(hfile,length,SEEK_CUR)) break;
				}
				while(1);
			}
		}
	}
	return 0;
}
